<?php
/**
 *-------------------------------------------------------------------------------
 *	JTL-Shop 2 admin file
 *
 * Do not use, modify or sell this code without permission / licence.
 *
 * @author Niclas Potthast <niclas@jtl-software.de>
 * @copyright JTL-Software 2008
 * @link http://jtl-software.de/jtlshop.php
 * @version v2.0 / 31.05.07
 *-------------------------------------------------------------------------------
*/
require_once("includes/admininclude.php");

$adminsession = new AdminSession();
checkLoggedIn();
require_once("includes/smartyinclude.php");

$pProvision = 0.03;

$nJahr = 0;
$nMonat = 0;
$nFilterOffen = 0;
$nFilterInBearbeitung = 0;
$nFilterBezahlt = 0;
$nFilterVersendet = 0;
$aUmsatz = array();
$bExport = 0;
$nStatusCount = 0;

$nSummeUmsatz=0;
$nSummeSteuern=0;
$nSummeBestellungen=0;
$nSummeProdukte=0;
$nSummeVersand=0;

if ($_REQUEST['month'])
	$nMonat = $_REQUEST['month'];
if ($_REQUEST['year'])
	$nJahr = $_REQUEST['year'];
if ($_POST['export']=='1')
	$bExport = intval($_POST['export']);

if (is_array($_POST['filter'])) {
	foreach ($_POST['filter'] as $filter)
	{
		if ($filter == 'offen')
		{
			$nFilterOffen = 1;
			$nStatusCount++;
		}
		if ($filter == 'bearbeitung')
		{
			$nFilterInBearbeitung = 1;
			$nStatusCount++;
		}
		if ($filter == 'bezahlt')
		{
			$nFilterBezahlt = 1;
			$nStatusCount++;
		}
		if ($filter == 'versendet')
		{
			$nFilterVersendet = 1;
			$nStatusCount++;
		}
	}
}

if ($nMonat>0) {
	$cGroupAndOrder="TAG";
} else {
	$cGroupAndOrder="MONAT";
}

$cSQL =
	"SELECT ".
		"SUM(twarenkorbpos.fPreis*((100+fMwSt)/100)*twarenkorbpos.nAnzahl) AS UMSATZ, ".
		"SUM((twarenkorbpos.fPreis*((100+fMwSt)/100)*twarenkorbpos.nAnzahl)-(twarenkorbpos.fPreis*twarenkorbpos.nAnzahl)) AS STEUERN, ";
if($nMonat>0)
	$cSQL.= "DAY(dErstellt) AS TAG, ";
$cSQL.=
		"YEAR(dErstellt) AS JAHR, ".
		"MONTH(dErstellt) AS MONAT ".
	"FROM tbestellung, twarenkorbpos ".
	"WHERE ".
		"1=1 ";
$cSQL.= "AND tbestellung.kWarenkorb = twarenkorbpos.kWarenkorb ";
$cSQL.= "AND YEAR(dErstellt) = '$nJahr' ";
if ($nMonat>0)
	$cSQL.= "AND MONTH(dErstellt) = '$nMonat' ";
$cSQL = addSQLStatus($cSQL,$nStatusCount,$nFilterOffen,$nFilterInBearbeitung,$nFilterBezahlt,$nFilterVersendet);
$cSQL.= "GROUP BY $cGroupAndOrder ";
$cSQL.= "ORDER BY $cGroupAndOrder ";
$umsatz = $GLOBALS["DB"]->executeQuery($cSQL,2);

$cSQL =
	"SELECT ".
		"SUM(twarenkorbpos.fPreis*((100+fMwSt)/100)*twarenkorbpos.nAnzahl) AS VERSAND, ";
if($nMonat>0)
	$cSQL.= "DAY(dErstellt) AS TAG, ";
$cSQL.=
		"YEAR(dErstellt) AS JAHR, ".
		"MONTH(dErstellt) AS MONAT ".
	"FROM tbestellung, twarenkorbpos ".
	"WHERE ".
		"1=1 ";
$cSQL.= "AND tbestellung.kWarenkorb = twarenkorbpos.kWarenkorb ";
$cSQL.= "AND (twarenkorbpos.nPosTyp = ".C_WARENKORBPOS_TYP_VERSANDPOS." ";
$cSQL.= "OR twarenkorbpos.nPosTyp = ".C_WARENKORBPOS_TYP_NACHNAHMEGEBUEHR.") ";
$cSQL.= "AND YEAR(dErstellt) = '$nJahr' ";
if ($nMonat>0)
	$cSQL.= "AND MONTH(dErstellt) = '$nMonat' ";
$cSQL = addSQLStatus($cSQL,$nStatusCount,$nFilterOffen,$nFilterInBearbeitung,$nFilterBezahlt,$nFilterVersendet);
$cSQL.= "GROUP BY $cGroupAndOrder ";
$cSQL.= "ORDER BY $cGroupAndOrder ";
$versand = $GLOBALS["DB"]->executeQuery($cSQL,2);

$cSQL =
	"SELECT ".
		"DISTINCT kBestellung, ".
		"COUNT(*) AS ANZBESTELL, ";
if($nMonat>0)
	$cSQL.= "DAY(dErstellt) AS TAG, ";
$cSQL.=
		"YEAR(dErstellt) AS JAHR, ".
		"MONTH(dErstellt) AS MONAT ".
	"FROM tbestellung, twarenkorbpos ".
	"WHERE ".
		"1=1 ";
$cSQL.= "AND tbestellung.kWarenkorb = twarenkorbpos.kWarenkorb ";
$cSQL.= "AND twarenkorbpos.nPosTyp = ".C_WARENKORBPOS_TYP_ARTIKEL." ";
$cSQL.= "AND YEAR(dErstellt) = '$nJahr' ";
//$cSQL.= "AND kArtikel > 0 ";
if ($nMonat>0)
	$cSQL.= "AND MONTH(dErstellt) = '$nMonat' ";
$cSQL = addSQLStatus($cSQL,$nStatusCount,$nFilterOffen,$nFilterInBearbeitung,$nFilterBezahlt,$nFilterVersendet);
$cSQL.= "GROUP BY $cGroupAndOrder ";
$cSQL.= "ORDER BY $cGroupAndOrder ";
$bestellanzahl = $GLOBALS["DB"]->executeQuery($cSQL,2);

$cSQL =
	"SELECT ".
		"SUM(nAnzahl) AS ANZPROD, ";
if($nMonat>0)
	$cSQL.= "DAY(dErstellt) AS TAG, ";
$cSQL.=
		"YEAR(dErstellt) AS JAHR, ".
		"MONTH(dErstellt) AS MONAT ".
	"FROM tbestellung, twarenkorbpos ".
	"WHERE 1=1 ";
$cSQL.= "AND tbestellung.kWarenkorb = twarenkorbpos.kWarenkorb ";
$cSQL.= "AND YEAR(dErstellt) = '$nJahr' ";
//$cSQL.= "AND kArtikel > 0 ";
$cSQL.= "AND twarenkorbpos.nPosTyp = ".C_WARENKORBPOS_TYP_ARTIKEL." ";
if ($nMonat>0)
	$cSQL.= "AND MONTH(dErstellt) = '$nMonat' ";
$cSQL = addSQLStatus($cSQL,$nStatusCount,$nFilterOffen,$nFilterInBearbeitung,$nFilterBezahlt,$nFilterVersendet);
$cSQL.=
	"GROUP BY $cGroupAndOrder ".
	"ORDER BY $cGroupAndOrder ";
$produktanzahl = $GLOBALS["DB"]->executeQuery($cSQL,2);

add($umsatz,'UMSATZ',$nMonat,&$nSummeUmsatz);
add($umsatz,'STEUERN',$nMonat,0,&$nSummeSteuern);
add($umsatz,'JAHR',$nMonat);
add($umsatz,'MONAT',$nMonat);
add($umsatz,'TAG',$nMonat);
add($bestellanzahl,'ANZBESTELL',$nMonat,0,0,&$nSummeBestellungen);
add($produktanzahl,'ANZPROD',$nMonat,0,0,0,&$nSummeProdukte);
add($versand,'VERSAND',$nMonat,0,0,0,0,&$nSummeVersand);

foreach ($aUmsatz as $obj)
{
	// provision
	$obj->PROVISION = gibPreisStringLocalized(($obj->UMSATZ - $obj->VERSAND - $obj->STEUERN) * $pProvision);
	$obj->STEUERN = gibPreisStringLocalized($obj->STEUERN);
	$obj->VERSAND = gibPreisStringLocalized($obj->VERSAND);
	$obj->UMSATZ  = gibPreisStringLocalized($obj->UMSATZ);

}

if ($_POST['export'] == "Exportieren")
{
	if (is_array($aUmsatz)) {
		$cCSV = erstelleCSV($aUmsatz);
		header('Content-type: text/csv');
		header('Content-Disposition: attachment; filename="statUmsatz.csv"');
		echo $cCSV;
		die();
	}
}

$smarty->assign('Umsatz',$aUmsatz);
$smarty->assign('FilterOffen',$nFilterOffen);
$smarty->assign('FilterInBearbeitung',$nFilterInBearbeitung);
$smarty->assign('FilterBezahlt',$nFilterBezahlt);
$smarty->assign('FilterVersendet',$nFilterVersendet);
$smarty->assign('year',intval($nJahr));
$smarty->assign('month',$nMonat);
$smarty->assign('current_year',date('Y'));
$smarty->assign('bNew',$_POST['bNew']);

$smarty->assign('nSummeUmsatz',gibPreisStringLocalized($nSummeUmsatz));
$smarty->assign('nSummeSteuern',gibPreisStringLocalized($nSummeSteuern));
$smarty->assign('nSummeBestellungen',$nSummeBestellungen);
//$smarty->assign('nSummeProdukte',sprintf("%.0d",$nSummeProdukte));
$smarty->assign('nSummeProdukte',$nSummeProdukte);
$smarty->assign('nSummeVersand',gibPreisStringLocalized($nSummeVersand));
// Summe Provision
$fProvision = (floatval($nSummeUmsatz) - floatval($nSummeSteuern) - floatval($nSummeVersand)) * $pProvision;
$smarty->assign('nSummeProvision',gibPreisStringLocalized($fProvision));
$smarty->assign('pProvisionsSatz',number_format($pProvision*100,2,",",""));

$smarty->display('statUmsatz.tpl');

function add($array,$valuename,$nMonat,$nSummeUmsatz=0,$nSummeSteuern=0,$nSummeBestellungen=0,$nSummeProdukte=0,$nSummeVersand=0)
{
	if (is_array($array))
	{
		foreach ($array as $key => $obj)
		{
			switch ($valuename)
			{
				case "UMSATZ":
					$nSummeUmsatz+=floatval($obj->$valuename);
				case "STEUERN":
					$nSummeSteuern+=floatval($obj->$valuename);
				case "ANZBESTELL":
					$nSummeBestellungen+=intval($obj->$valuename);
				case "ANZPROD":
					$nSummeProdukte+=intval($obj->$valuename);
				case "VERSAND":
					$nSummeVersand+=floatval($obj->$valuename);
			}

			if ($nMonat>0)	{
				$GLOBALS['aUmsatz'][$obj->TAG]->$valuename = $obj->$valuename;
			} else {
				$GLOBALS['aUmsatz'][$obj->MONAT]->$valuename = $obj->$valuename;
			}
		}
	}
}

function addSQLStatus($cSQL,$nStatusCount,$nFilterOffen,$nFilterInBearbeitung,$nFilterBezahlt,$nFilterVersendet)
{
	if ($nStatusCount > 0)
	{
		$cSQL.= "AND ( ";

		if ($nFilterOffen)
		{
			$cSQL.= "(tbestellung.cStatus = '".BESTELLUNG_STATUS_OFFEN."') ";
		}
		if ($nFilterInBearbeitung)
		{
			if($nFilterOffen) $cSQL.= "OR ";
			$cSQL.= "(tbestellung.cStatus = '".BESTELLUNG_STATUS_IN_BEARBEITUNG."') ";
		}
		if ($nFilterBezahlt)
		{
			if($nFilterOffen || $nFilterInBearbeitung) $cSQL.= "OR ";
			$cSQL.= "(tbestellung.cStatus = '".BESTELLUNG_STATUS_BEZAHLT."') ";
		}
		if ($nFilterVersendet)
		{
			if($nStatusCount>1) $cSQL.= "OR ";
			$cSQL.= "(tbestellung.cStatus = '".BESTELLUNG_STATUS_VERSANDT."') ";
		}
		$cSQL.= ") ";
	}
	return $cSQL;
}
?>